#include <SFML/Graphics.hpp>
#include <SFML/System.hpp>
#include <SFML/Window.hpp>
#include <SFML/Audio.hpp>
#include <SFML/Network.hpp>

#include <cmath>
#include <sstream>

enum BUTTONS {A = 0, f, T, L, C, R2, R, Unit1, Unit2, Unit3};

class Simulator
{
private:
    sf::VideoMode videoMode;
    sf::RenderWindow * window;
    sf::Event sfmlEvent;
    sf::RectangleShape backgroundU, backgroundParameters, backgroundUnits, backgroundSetValue, backgroundList, backgroundPlot;
    sf::Color lightgray = sf::Color(211, 211, 211, 255);
    sf::Color darkgray = sf::Color(192, 192, 192, 255);
    sf::Color buttoncolor = sf::Color(69, 69, 69, 255);
    sf::Vertex plotline[2][18];
    sf::Font font;
    sf::Text textT, textA, textf, textL, textC, textR2, textR, textUnit1, textUnit2, textUnit3;
    sf::Text valuemarker[10];
    sf::Text timemarker[10];
    sf::Texture textureSin1, textureSin2, textureTri1, textureTri2, textureSqr1, textureSqr2;
    sf::Sprite sin, tri, sqr;
    //sf::RectangleShape rectA, rectf, rectT, rectL, rectC, rectR2, rectR, rectUnit1, rectUnit2, rectUnit3;
    sf::RectangleShape rect[10];
    sf::Vertex functionline[2][1000];
    enum PlotType {TimeResponse, BodeAmplitude, BodePhase};
    PlotType PlotType = TimeResponse;
    sf::Text curNumText;
    sf::Text values;
    sf::Text axisUnit;

     int activeRLC;
     int activeSignal;
     int activeSignalParam;
     int activeUnit;

     double Am, Res, Lin, Cap, w, Time, SimulationDuration, freq, Res2;

    void initWindow();

    void buttonPressed(int x, int y);

    int numButtonPressed();
    void inputParameter(int x);

    void sinResponse();
    void rectangleResponse();
    void triangleResponse();

    bool t2;
    double curNum;
    bool dot;
    int aftDot;
public:
    Simulator(/* args */);
    ~Simulator();

    bool running();
    void pollEvents();

    void numToStr();

    void display();

    sf::RectangleShape rectanglesetup(int posx, int posy, float sizex, float sizey, sf::Color color);
    bool hover(sf::RectangleShape rect, sf::RenderWindow& window);

    double heaviside(double t, double hi);
    double trianglewave(double t, double T, double A);
    void createplot(double A[], int calculationpoints);
    void createplotBode(double A[], bool isAmplitude);
};
